//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers  2
#property indicator_color1   PaleVioletRed
#property indicator_color2   Silver
#property indicator_width1   2
#property indicator_minimum  0
#property indicator_maximum  100
#property indicator_level1   30
#property indicator_level2   70

//
//
//
//
//

extern int    RsiPeriod    =  9;
extern int    RsiPrice     = PRICE_CLOSE;
extern int    Smooth1      = 50;
extern int    Smooth2      =  5;
extern int    SignalPeriod =  5;

//
//
//
//
//

double rsi[];
double rss[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,rsi);
   SetIndexBuffer(1,rss);
   IndicatorShortName("Dynamic RSI ("+RsiPeriod+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int countedBars = IndicatorCounted();
      if (countedBars<0) return(-1);
      if (countedBars>0) countedBars--;
         int limit = MathMin(Bars-countedBars,Bars-1);
   
   //
   //
   //
   //
   //

      for(int i=limit; i >= 0; i--)
      {
         double trsi = iRSI(NULL,0,RsiPeriod,RsiPrice,i);
         double y    = iSma(50-(iSma(trsi,Smooth1,i,0)-trsi),Smooth2,i,1);
         double z    = iSma(y,SignalPeriod,i,2);
            rsi[i] = y;
            rss[i] = z;
      }
   return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workSma[][6];
double iSma(double price, int period, int r, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= Bars) ArrayResize(workSma,Bars); instanceNo *= 2; r=Bars-r-1;

   //
   //
   //
   //
   //
      
   workSma[r][instanceNo] = price;
   if (r>=period)
          workSma[r][instanceNo+1] = workSma[r-1][instanceNo+1]+(workSma[r][instanceNo]-workSma[r-period][instanceNo])/period;
   else { workSma[r][instanceNo+1] = 0; for(int k=0; k<period && (r-k)>=0; k++) workSma[r][instanceNo+1] += workSma[r-k][instanceNo];  
          workSma[r][instanceNo+1] /= k; }
   return(workSma[r][instanceNo+1]);
}

